clear all;

%time step
dt = 0.001; 
init_t=0;
Simtime = 100;
save_dt = 5;
tsave = init_t:save_dt:Simtime;
Trajectories = 5;
SavePoints = length(tsave);
X_all_P{1} = zeros(Trajectories,SavePoints);
X_all_P{2} = zeros(Trajectories,SavePoints);
X_all_P{3} = zeros(Trajectories,SavePoints);
X_all_P{4} = zeros(Trajectories,SavePoints); 


%p = 0.0003; 
for i = 1:Trajectories
%initial states
S = 1000;
E = 3; 
SE = 0;
P = 0;
species = [S;E;SE;P];
species_vec = zeros(length(tsave), length(species)); 
%stoich. matrix
    %r1 r2 r3 r4
V = [-1 1  0 -1; %S
     -1 1  1  0; %E
      1 -1 -1 0; %ES
      0  0  1 0];%P

%model parameters
kon = 0.1; 
koff = 0.05; 
kcat = 10; 
kdeg = 0.01;
 tic
count=0;
    for curr_t = init_t:dt:Simtime
        %curr_t

        %numbers of each reaction happened
        rctvec  = poissrnd(dt*[kon*S*E;koff*SE;kcat*SE;kdeg*S ]);
        %rctvec  = zeros(4,1);
        
        %update state
        statechange = V * rctvec;
        species  = max(species + statechange,0);

        S = species(1);
        E = species(2);
        SE = species(3);
        P = species(4);
        
        if ~mod(curr_t,save_dt)
           count=count+1;
           species_vec(count, :) = species';
        end

        %update time
        %curr_t = curr_t + dt;
    end
  
    X_all_P{1}(i,:) = species_vec(:,1);%substrate
    X_all_P{2}(i,:) = species_vec(:,2);%enzyme
    X_all_P{3}(i,:) = species_vec(:,3);%E:S
    X_all_P{4}(i,:) = species_vec(:,4);%product

end
toc
%%
figure(1)
  subplot(2,2,1)
    hold on
    stairs(tsave,mean(X_all_P{1}),'k--')
    errorbar(tsave,mean(X_all_P{1}),std(X_all_P{1}),'s')
    xlim([0 Simtime])
    title('S')
  subplot(2,2,2)
    hold on
    stairs(tsave,mean(X_all_P{2}),'k--')
    errorbar(tsave,mean(X_all_P{2}),std(X_all_P{2}),'s')
    xlim([0 Simtime])
    title('E')
  subplot(2,2,3)
    hold on
    stairs(tsave,mean(X_all_P{3}),'k--')
    errorbar(tsave,mean(X_all_P{3}),std(X_all_P{3}),'s')
    xlim([0 Simtime])
    title('ES')
  subplot(2,2,4)
    hold on
    stairs(tsave,mean(X_all_P{4}),'k--')
    errorbar(tsave,mean(X_all_P{4}),std(X_all_P{4}),'s')
    xlim([0 Simtime])
    title('P')

