%clear workspace
%close all;
clear all;

%rand('state',100)
Vol = 100;
Na = 6.022e23;
%stoichiometric matrix
V = [-1  1  0 -1; 
     -1  1  1  0; 
      1 -1 -1  0; 
      0  0  1  0];

c(1) =  0.1;    %kon
c(2) =  0.05;   %koff
c(3) = 10;      %kcat
c(4) =  0.01;   %kdeg
 

tfinal = 100;
tsave = 0:5:tfinal;
NrStorePoints = length(tsave);
NrRealizations = 5;
%%%%%%%%%% Parameters and Initial Conditions %%%%%%%%%

X_all_P{1} = zeros(NrRealizations,NrStorePoints);
X_all_P{2} = zeros(NrRealizations,NrStorePoints);
X_all_P{3} = zeros(NrRealizations,NrStorePoints);
X_all_P{4} = zeros(NrRealizations,NrStorePoints);


for i = 1:NrRealizations
    X = zeros(4,1);
    X(1) = 1000;% molecules of S
    X(2) = 3;   % molecules of E 
    X(3) = 0;   % molecules of [E:S]
    X(4) = 0;   % molecules of P
    
    t = 0;

    xout = zeros(4,NrStorePoints);
    % save initial
    idx = find(t<=tsave,1,'first');
    xout(:,idx:NrStorePoints)=X*ones(1,NrStorePoints-idx+1);


    while t < tfinal

        %plot(t,X(2:end),'s')
         a(1) = (c(1)*X(1)*X(2))/Vol;
         a(2) = c(2)*X(3);
         a(3) = c(3)*X(3);
         a(4) = c(4)*X(1);
         asum = sum(a);
         if asum == 0
             break
         end
         j = min(find(rand<=cumsum(a/asum)));
         tau = log(1/rand)/asum;
         X = X + V(:,j);
         t = t + tau;
         %save state after execution of reaction
         idx = find(t<=tsave,1,'first');
         xout(:,idx:NrStorePoints)=X*ones(1,NrStorePoints-idx+1);
    end
    %xout = xout./Na;
    
    X_all_P{1}(i,:) = xout(1,:);%substrate
    X_all_P{2}(i,:) = xout(2,:);%enzyme
    X_all_P{3}(i,:) = xout(3,:);%E:S
    X_all_P{4}(i,:) = xout(4,:);%product
    
end % over all realizations
    figure(1)
    subplot(2,2,1)
    hold on
    stairs(tsave,mean(X_all_P{1}),'k--')
    errorbar(tsave,mean(X_all_P{1}),std(X_all_P{1}),'s')
    xlim([0 tfinal])
    title('S')
    subplot(2,2,2)
    hold on
    stairs(tsave,mean(X_all_P{2}),'k--')
    errorbar(tsave,mean(X_all_P{2}),std(X_all_P{2}),'s')
    xlim([0 tfinal])
    title('E')
    subplot(2,2,3)
    hold on
    stairs(tsave,mean(X_all_P{3}),'k--')
    errorbar(tsave,mean(X_all_P{3}),std(X_all_P{3}),'s')
    xlim([0 tfinal])
    title('ES')
    subplot(2,2,4)
    hold on
    stairs(tsave,mean(X_all_P{4}),'k--')
    errorbar(tsave,mean(X_all_P{4}),std(X_all_P{4}),'s')
    xlim([0 tfinal])
    title('P')